#include <iostream>
#include <fstream>
using namespace std;

const int MAXS = 100;
const int MAXA = 200;

enum Categ {ALIMENTARI, CASALINGHI, GIOCATTOLI};

struct Articolo {
  int codice;
  char descr[MAXS];
  Categ categoria;
  float prezzo;
};
struct Listino {
  Articolo art[MAXA];
  int numArt;
};


void scontrino(const Listino* pl, const int c[], const int q[], int n);
int caricaListino(Listino* pl, const char nomef[]);
bool prezzoMax(const Listino* pl, const int c[], int n, Articolo* pa);
void stampaPrezziMedi(const Listino* pl);
int seleziona(const Listino* pl, char operatore, int cod, Articolo v[]);

void menu(){
  cout << "\n--------------------" << endl;
  cout << "1) carica listino" << endl;
  cout << "2) scontrino" << endl;
  cout << "3) prezzo max" << endl;
  cout << "4) stampa prezzi medi" << endl;
  cout << "5) seleziona" << endl;
  cout << "6) stampa tutto" << endl;
  cout << "7) esci" << endl;
  cout << "? ";
}

int main(){
  Listino lis;
  lis.numArt = 0;
  char c, o;
  int n, cod;
  int cc[MAXA];
  int qq[MAXA];
  Articolo a;
  bool res;
  Articolo articoli[MAXA];

  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        n = caricaListino(&lis, "input.txt");
        cout << "Ho caricato " << n << " articoli" << endl;
        break;
      case '2':
        cout << "Quanti? ";
        cin >> n;
        for(int i=0; i<n; i++) {
          cout << "Codice? ";
          cin >> cc[i];
          cout << "Quantita`? ";
          cin >> qq[i];
        }
        scontrino(&lis, cc, qq, n);
        break;
      case '3':
        cout << "Quanti? ";
        cin >> n;
        for(int i=0; i<n; i++) {
          cout << "Codice? ";
          cin >> cc[i];
        }
        res = prezzoMax(&lis, cc, n, &a);
        if(res) {
          cout << "Articolo con il prezzo max:" << endl;
          cout << a.codice << endl;
          cout << a.descr << endl;
          cout << a.prezzo << endl;
        } else 
          cout << "Listino vuoto" << endl;
        break;
      case '4':
        stampaPrezziMedi(&lis);
        break;
      case '5':
        cout <<  "Operatore? ";
        cin >> o;
        cout << "Codice? ";
        cin >> cod;
        n = seleziona(&lis, o, cod, articoli);
        cout << "Sono stati selezionati i seguenti articoli (codice e descr):" << endl;
        for(int i=0; i<n; i++)
          cout << articoli[i].codice << " " << articoli[i].descr << endl;
        break;
      case '6':
        for(int i=0; i<lis.numArt; i++) {
          cout << "----------------------------" << endl;
          cout << lis.art[i].codice << " " << lis.art[i].descr << " " << lis.art[i].prezzo << " ";
          switch(lis.art[i].categoria) {
            case ALIMENTARI: cout << "A" << endl;
                break;
            case CASALINGHI: cout << "C" << endl;
                break;
            case GIOCATTOLI: cout << "G" << endl;
                break;
          }
        }
        break;
      case '7':
        return 0;
        break;
    }
  } 
}
